#define NEXBUF_SIZE 8
byte nexBuffer[NEXBUF_SIZE] = { 0x00 };
byte nexCounter = 0;
byte nexFFcounter = 0;
bool nexCmdReady = false;
bool nexOverflow = false;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
}

void loop() {
  // put your main code here, to run repeatedly:
  if (Serial.available())  // check if there is something to read
  {
    byte c = Serial.read();     // read the byte
    nexBuffer[nexCounter] = c;  // copy the byte over to our nexBuffer
    // do the terminator check logic
    if (c == 0xFF) {
      nexFFcounter++;  // ah, a 0xFF !
    } else {
      nexFFcounter = 0;  // that wasn't a 0xFF - start over
    }
    // let's see if there are enough terminator bytes
    if (nexFFcounter == 3) {
      nexCmdReady = true;  // we received 3 consecutive 0xFF and are done
    } else {
      nexCmdReady = false;  // we aren't yet done...
    }
    nexCounter++;  // position for the next byte to come
    // do a buffer overflow check
    if (nexCounter >= NEXBUF_SIZE) {
      nexOverflow = true;  // set the error flag
      nexCounter = 0;      // reset the pointer to avoid writing out of the buffer bounds
    }
  }
  // phew... after all these checks on byte and buffer level, let's look onto the whole frame
  // if 3 consecutive 0xFF have been received:
  if (nexCmdReady) {
    if (!nexOverflow) {                               // process only if there were no errors
      if (nexCounter == 7 && nexBuffer[0] == 0x65) {  // check if we received exactly 7 bytes starting with 0x65
        byte page = nexBuffer[1];
        byte objId = nexBuffer[2];
        byte event = nexBuffer[3];
        // The following lines give just some output on the Serial monitor,
        // Replace with meaningful code like using GPIO to switch LEDs or relays or whatever...
        Serial.print("Touch ");
        if (event == 1) {
          Serial.print("press");
        } else {
          Serial.print("release");
        }
        Serial.print(" event on page ");
        Serial.print(page);
        Serial.print(" by object with ID ");
        Serial.println(objId);
      }
    }
    // reset everything:
    nexCmdReady = false;
    nexOverflow = false;
    nexFFcounter = 0;
    nexCounter = 0;
  }
}
